# mwm-ml-gen

[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.1117837.svg)](https://doi.org/10.5281/zenodo.1117837)

**mwm-ml-gen** (**M**orris **W**ater **M**aze - **M**achine **L**earning - **G**eneralized) is a complete set of tools for analysis and classification of rodent trajectories inside the Morris Water Maze. 

For more information about 'how to use' this software visit our [wiki](https://github.com/RodentDataAnalytics/mwm-ml-gen/wiki).

For more information about the analysis and the classification procedure refer to the publication of [Gehring, T. V. et al.](http://www.nature.com/articles/srep14562) and [Vouros et al](https://arxiv.org/abs/1711.07446). The results of [Gehring, T. V. et al.](http://www.nature.com/articles/srep1456) can be reproduced by using the code mwm-ml ([github](https://github.com/RodentDataAnalytics/mwm-ml) or [bitbucket](https://bitbucket.org/tiagogehring/mwm_trajectories)).

For questions contact Avgoustinos Vouros (avouros1@sheffield.ac.uk)

# Citations for software that we have used in this project

If you are the developer of any of the below software and would like us to change how we cite it, please contact us.

* [WekaUT](http://www.cs.utexas.edu/users/ml/risc/code/) - WekaUT contains a modified version of Weka. Some of the modifications include classes to handle semi-supervised clustering of text data.
* MATLAB and Statistics Toolbox, The MathWorks, Inc., Natick, Massachusetts, United States.
* [detect_UTF_encoding.m](https://uk.mathworks.com/matlabcentral/answers/uploaded_files/45445/detect_UTF_encoding.m) written by [Walter Roberson](https://uk.mathworks.com/matlabcentral/profile/authors/434782-walter-roberson) is being used to read UTF16LE txt files. Original code has minor modifications.
* [This code chunk](https://uk.mathworks.com/help/matlab/matlab_external/read-special-system-folder-path.html) is being used to get special folder paths in Windows OS (for MAC OS java.lang.System.getProperty is being used).
* Moshtagh, Nima (2009). [Minimum Volume Enclosing Ellipsoid](https://uk.mathworks.com/matlabcentral/fileexchange/9542-minimum-volume-enclosing-ellipsoid), MATLAB Central File Exchange. Retrieved May 18, 2014.
