function [new_properties] = fix_properties(properties,days,trials)
%FIX_PROPERTIES centralizes the arena to the point 0,0

    new_properties = {};
    % Check if they are correct
    [error] = check_properties(properties);    
    if error
        return;
    end    
    
    % Update centre and platform location
    new_plat_x = properties{5} - properties{2};
    new_plat_y = properties{6} - properties{3};
    if properties{8}
        new_plat_x = -new_plat_x;
    end
    if properties{9}
        new_plat_y = -new_plat_y;
    end    
    
    new_properties = {'TRIAL_TIMEOUT',properties{1},...
                        'CENTRE_X',0,...
                        'CENTRE_Y',0,...
                        'ARENA_R',properties{4},...
                        'PLATFORM_X',new_plat_x,...
                        'PLATFORM_Y',new_plat_y,...
                        'PLATFORM_R',properties{7},...
                        'FLIP_X',properties{8},...
                        'FLIP_Y',properties{9},...
                        'OLD_CENTRE_X',properties{2},...
                        'OLD_CENTRE_Y',properties{3},...
                        'OLD_PLATFORM_X',properties{5},...
                        'OLD_PLATFORM_Y',properties{6},...
                        'DAYS',days, 'TRIALS',trials};
end

